-- Joystick routines for ESE by Jeffrey Fielding (JJProg@cyberbury.net)
-- Using joystk.e (I've added 4-button functionality)
include ese.e
include joystk.e
sequence lastButtons, lastPositions, buttonEvents, moveEvents
sequence buttonUsers, moveUsers
sequence moveGenerators, buttonGenerators
lastButtons = {get_buttons(1),get_buttons(2)}
lastPositions = {get_stick_pos(1),get_stick_pos(2)}
moveEvents = {-1,-1}
buttonEvents = repeat(repeat(-1,4),2)
buttonUsers = repeat(repeat(0,4),2)
moveUsers = {0,0}
procedure JoystickCheckButtons(integer joystick)
    sequence buttons
    trace(1)
    buttons = get_buttons(joystick)
    for i = 1 to 4 do
	if buttons[i] != lastButtons[joystick][i] then
	    if buttonEvents[joystick][i] != -1 then
		FireEvent(buttonEvents[joystick][i],{buttons[i]})
	    end if
	end if
    end for
    lastButtons[joystick] = buttons
end procedure
procedure JoystickCheckMove(integer joystick)
    sequence pos
    pos = get_stick_pos(joystick)
    if compare(pos,lastPositions[joystick]) then
	if moveEvents[joystick] != -1 then
	    FireEvent(moveEvents[joystick],pos)
	end if
    end if
    lastPositions[joystick] = pos
end procedure
moveGenerators = {AddAdvancedGenerator(routine_id("JoystickCheckMove"),{1}),
		  AddAdvancedGenerator(routine_id("JoystickCheckMove"),{2})}
buttonGenerators = {AddAdvancedGenerator(routine_id("JoystickCheckButtons"),{1}),
		    AddAdvancedGenerator(routine_id("JoystickCheckButtons"),{2})}
DisableEventGenerator(moveGenerators[1])
DisableEventGenerator(moveGenerators[2])
DisableEventGenerator(buttonGenerators[1])
DisableEventGenerator(buttonGenerators[2])
global function AddJoystickButtonEvent(integer joystick, integer button)
    if buttonEvents[joystick][button] = -1 then
	if equal(buttonUsers[joystick],{0,0,0,0}) then
	    EnableEventGenerator(buttonGenerators[joystick])
	end if
	buttonUsers[joystick][button] += 1
	buttonEvents[joystick][button] = AddEvent()
    end if
    return buttonEvents[joystick][button]
end function
global function AddJoystickMoveEvent(integer joystick)
    if moveEvents[joystick] = -1 then
	if moveUsers[joystick] = 0 then
	    EnableEventGenerator(moveGenerators[joystick])
	end if
	moveUsers[joystick] += 1
	moveEvents[joystick] = AddEvent()
    end if
    return moveEvents[joystick]
end function
global procedure RemoveJoystickButtonEvent(integer joystick, integer button)
    buttonUsers[joystick][button] -= 1
    if buttonUsers[joystick][button] = 0 then
	RemoveEvent(buttonEvents[joystick][button])
	buttonEvents[joystick][button] = -1
    end if
    if equal(buttonUsers[joystick][button],{0,0,0,0}) then
	DisableEventGenerator(buttonGenerators[joystick])
    end if
end procedure
global procedure RemoveJoystickMoveEvent(integer joystick)
    moveUsers[joystick] -= 1
    if moveUsers[joystick] = 0 then
	RemoveEvent(moveEvents[joystick])
	moveEvents[joystick] = -1
    end if
    if moveUsers[joystick] = 0 then
	DisableEventGenerator(moveGenerators[joystick])
    end if
end procedure

