-- Sound effects for ESE based on sfx2.e
-- By Jeffrey Fielding (JJProg@cyberbury.net)
include ese.e
include sfx2.e
sequence soundDoneEvents, soundDoneGenerators, soundDones, soundDoneUsers
soundDoneEvents = {}
soundDoneGenerators = {}
soundDones = {}
soundDoneUsers = {}
procedure RemoveSoundDoneEvent(integer i)
    RemoveEvent(soundDoneEvents[i])
    RemoveEventGenerator(soundDoneGenerators[i])
    soundDones[i] = -1
    soundDoneEvents[i] = -1
    soundDoneGenerators[i] = -1
end procedure
procedure SoundDoneGenerator(integer index)
    integer i
    if SoundDone(index) then
	i = find(index,soundDones)
	FireEvent(soundDoneEvents[i],{})
	RemoveSoundDoneEvent(i)
    end if
end procedure
constant SOUND_DONE_GENERATOR = routine_id("SoundDoneGenerator")
global function AllocateSoundDoneEvent(integer index)
    integer i
    i = find(index,soundDones)
    if i then
	soundDoneUsers[i] += 1
	return soundDoneEvents[i]
    else
	i = find(-1,soundDones)
	if i then
	    soundDones[i] = index
	    soundDoneEvents[i] = AddEvent()
	    soundDoneGenerators[i] = AddAdvancedGenerator(SOUND_DONE_GENERATOR,{index})
	    soundDoneUsers[i] = 1
	    return soundDoneEvents[i]
	else
	    i = AddEvent()
	    soundDones &= index
	    soundDoneEvents &= i
	    soundDoneGenerators &= AddAdvancedGenerator(SOUND_DONE_GENERATOR,{index})
	    soundDoneUsers &= 1
	    return i
	end if
    end if
end function
global procedure DeallocateSoundDoneEvent(integer index)
    integer i
    i = find(index,soundDones)
    if i then
	soundDoneUsers[i] -= 1
	if soundDoneUsers[i] = 0 then
	    RemoveSoundDoneEvent(i)
	end if
    end if
end procedure
