include ese.e
include gfx.e
constant SPRITE_SOURCE = 1,
	 SPRITE_ROTATED = 2,
	 SPRITE_BACKGROUND = 3,
	 SPRITE_SIZE = 4,
	 SPRITE_CENTER = 5,
	 SPRITE_POSITION = 6,
	 SPRITE_TOPLEFT = 7,
	 SPRITE_ROTATION = 8,
	 SPRITE_MASK = 9,
	 SPRITE_TRANSPARENT = 10,
	 SPRITE_COLLISIONID = 11,
	 SPRITE_DISPLAYPOS = 12
constant collide = allocate(73)
poke(collide, {
    #60,                    --    0: pushad
    #BE,#00,#00,#00,#00,    --    1: mov esi, 0 ; Mask
    #BF,#00,#00,#00,#00,    --    6: mov edi, 0 ; Mask buffer
    #B8,#00,#00,#00,#00,    --    B: mov eax, 0 ; Height
    #B9,#00,#00,#00,#00,    --   10: mov ecx, 0 ; Width
    #BB,#00,#00,#00,#00,    --   15: mov ebx, 0 ; Inc
			    --   1A: lineloop:
    #51,                    --   1A: push ecx
			    --   1B: pixelloop:
    #8A,#16,                --   1B: mov dl, byte ptr [esi]
    #80,#FA,#00,            --   1D: cmp dl, 0
    #74,#09,                --   20: je skippixel
    #8A,#37,                --   22: mov dh, byte ptr [edi]
    #80,#FE,#00,            --   24: cmp dh, 0
    #75,#15,                --   27: jne collision
    #88,#17,                --   29: mov byte ptr [edi], dl
			    --   2B: skippixel:
    #47,                    --   2B: inc edi
    #46,                    --   2C: inc esi
    #49,                    --   2D: dec ecx
    #83,#F9,#00,            --   2E: cmp ecx, 0
    #75,#E8,                --   31: jne pixelloop
    #48,                    --   33: dec eax
    #01,#DF,                --   34: add edi, ebx
    #59,                    --   36: pop ecx
    #83,#F8,#00,            --   37: cmp eax, 0
    #75,#DE,                --   3A: jne lineloop
    #61,                    --   3C: popad
    #C3,                    --   3D: ret
			    --   3E: collision:
    #B8,#00,#00,#00,#00,    --   3E: mov eax, 0 ; 2 bytes 1 = sourceid, 2 = destid
    #66,#89,#10,            --   43: mov word ptr [eax], dx
    #59,                    --   46: pop ecx
    #61,                    --   47: popad
    #C3})                   --   48: ret
constant COLLIDE_MASK = collide+#2
constant COLLIDE_MASKBUFFER = collide+#7
constant COLLIDE_HEIGHT = collide+#C
constant COLLIDE_WIDTH = collide+#11
constant COLLIDE_INC = collide+#16
constant COLLIDE_BUFFER = collide+#3F
constant MakeMask = allocate(36)
poke(MakeMask, {
    #60,                    --    0: pushad
    #B8,#00,#00,#00,#00,    --    1: mov eax, 0 ; Image
    #BB,#00,#00,#00,#00,    --    6: mov ebx, 0 ; Mask
    #B9,#00,#00,#00,#00,    --    B: mov ecx, 0 ; Size
			    --   10: maskloop:
    #8A,#10,                --   10: mov dl, BYTE PTR [eax]
    #80,#FA,#00,            --   12: cmp dl, 0  ; Transparent color
    #75,#03,                --   15: jne skipmask
    #C6,#03,#00,            --   17: mov BYTE PTR [ebx], 0 ; Collision id
			    --   1A: skipmask:
    #40,                    --   1A: inc eax
    #43,                    --   1B: inc ebx
    #49,                    --   1C: dec ecx
    #83,#F9,#00,            --   1D: cmp ecx, 0
    #75,#EE,                --   20: jne maskloop
    #61,                    --   22: popad
    #C3})                   --   23: ret
constant mask_image = MakeMask+#2
constant mask_mask = MakeMask+#7
constant mask_size = MakeMask+#C
constant mask_trans = MakeMask+#14
constant mask_clid = MakeMask+#19
sequence  sprites
sequence collisionEvents
atom buffer, maskbuffer, CollisionInfo
global function AllocateCollisionEvent()
    integer event, i
    i = find(-1,collisionEvents)
    if i then
	event = AddEvent()
	collisionEvents[i] = event
	return event
    else
	return 0
    end if
end function
global procedure DeallocateCollisionEvent(integer event)
    integer i
    i = find(event,collisionEvents)
    if i then
	collisionEvents[i] = -1
    end if
end procedure
global function GetCollisionId(integer event)
    return find(event,collisionEvents)
end function
global procedure BlitSpriteBuffer()
    CopyBlit(buffer,SCREEN)
end procedure
procedure FreeSpriteBuffers()
    if buffer then
	free(buffer)
	buffer = 0
    end if
    if maskbuffer then
	free(maskbuffer)
	maskbuffer = 0
    end if
end procedure
function CreateMask(atom image, integer transparent, integer collisionid)
    sequence size
    atom mask
    integer bytesize
    size = GetBitmapSize(image)
    mask = AllocateScreen(size[1],size[2])
    bytesize = size[1]*size[2]
    mem_set(mask+8,0,bytesize)
    if collisionid then
	poke4(mask_image,image+8)
	poke4(mask_mask,mask+8)
	poke4(mask_size,bytesize)
	poke(mask_trans,transparent)
	poke(mask_clid,collisionid)
	call(MakeMask)
    end if
    return mask
end function
global function ClipSprite(integer sprite)
    integer startx, starty, newwidth, newheight
    integer x, y, width, height
    atom a, b
    if sprite < 1 or sprite > length(sprites) then
	return -1
    end if
    if integer(sprites[sprite]) then
	return -1
    end if
    x = sprites[sprite][SPRITE_TOPLEFT][1]
    y = sprites[sprite][SPRITE_TOPLEFT][2]
    width = sprites[sprite][SPRITE_SIZE][1]
    height = sprites[sprite][SPRITE_SIZE][2]
    if x + width > 320 then
	newwidth = 320-x
    else
	newwidth = width
    end if
    if y + height > 200 then
	newheight = 200-y
    else
	newheight = height
    end if
    if x < 0 then
	startx = (-x)
	newwidth += x
	x = 0
    else
	startx = 0
    end if
    if y < 0 then
	starty = (-y)
	newheight += y
	y = 0
    else
	starty = 0
    end if
    if newwidth > 0 and newheight > 0 then
	a = AllocateScreen(newwidth,newheight)
	b = AllocateScreen(newwidth,newheight)
	BlitArea(sprites[sprite][SPRITE_ROTATED],a,0,0,startx,starty,newwidth,newheight)
	BlitArea(sprites[sprite][SPRITE_MASK],b,0,0,startx,starty,newwidth,newheight)
	return {x,y,a,b}
    else
	return 0
    end if
end function
procedure UpdatePosition(integer sprite)
    sprites[sprite][SPRITE_TOPLEFT] = sprites[sprite][SPRITE_POSITION]-sprites[sprite][SPRITE_CENTER]
end procedure
procedure UpdateCenter(integer sprite)
    sprites[sprite][SPRITE_CENTER] = floor(sprites[sprite][SPRITE_CENTER]/2)
end procedure
procedure UpdateSize(integer sprite)
    sprites[sprite][SPRITE_SIZE] = GetBitmapSize(sprites[sprite][SPRITE_ROTATED])
end procedure
global procedure RotateSprite(integer spriteid, atom rotation)
    if rotation then
	rotation += sprites[spriteid][SPRITE_ROTATION]
	rotation = remainder(rotation,360)
	if rotation < 0 then
	    rotation = 360-rotation
	end if
	sprites[spriteid][SPRITE_ROTATION] = rotation
	if sprites[spriteid][SPRITE_ROTATED] and sprites[spriteid][SPRITE_ROTATED] != sprites[spriteid][SPRITE_SOURCE] then
	    free(sprites[spriteid][SPRITE_ROTATED])
	end if
	sprites[spriteid][SPRITE_ROTATED] = RotateBitmap(sprites[spriteid][SPRITE_SOURCE],sprites[spriteid][SPRITE_ROTATION],sprites[spriteid][SPRITE_TRANSPARENT])
	free(sprites[spriteid][SPRITE_MASK])
	sprites[spriteid][SPRITE_MASK] = CreateMask(sprites[spriteid][SPRITE_ROTATED],sprites[spriteid][SPRITE_TRANSPARENT],sprites[spriteid][SPRITE_COLLISIONID])
	UpdateSize(spriteid)
	UpdateCenter(spriteid)
	UpdatePosition(spriteid)
    end if
end procedure
global procedure SetSpritePosition(integer spriteid, atom x, atom y)
    sprites[spriteid][SPRITE_POSITION] = {x,y}
    UpdatePosition(spriteid)
end procedure
global procedure MoveSprite(integer spriteid, atom x, atom y)
    sprites[spriteid][SPRITE_POSITION] += {x,y}
    UpdatePosition(spriteid)
end procedure
procedure CollisionDetect(atom mask, integer x, integer y)
    sequence size
    integer a, b
    size = GetBitmapSize(mask)
    mem_set(CollisionInfo,0,2)
    poke4(COLLIDE_MASK,mask+8)
    poke4(COLLIDE_MASKBUFFER,maskbuffer+8+(320*y)+x)
    poke4(COLLIDE_HEIGHT,size[2])
    poke4(COLLIDE_WIDTH,size[1])
    poke4(COLLIDE_INC,320-size[1])
    poke4(COLLIDE_BUFFER,CollisionInfo)
    call(collide)
    if peek(CollisionInfo) then
	a = peek(CollisionInfo)
	b = peek(CollisionInfo+1)
	FireEvent(collisionEvents[a],{a,b})
	FireEvent(collisionEvents[b],{b,a})
    end if
end procedure
global procedure DisplaySprite(integer spriteid)
    object s, t
    if sequence(sprites[spriteid][SPRITE_DISPLAYPOS]) then
	if sprites[spriteid][SPRITE_BACKGROUND] then
	    Blit(sprites[spriteid][SPRITE_BACKGROUND],buffer,sprites[spriteid][SPRITE_DISPLAYPOS][1],sprites[spriteid][SPRITE_DISPLAYPOS][2])
	end if
    end if
    s = ClipSprite(spriteid)
    if integer(s) then
	if sprites[spriteid][SPRITE_BACKGROUND] then
	    free(sprites[spriteid][SPRITE_BACKGROUND])
	end if
	sprites[spriteid][SPRITE_BACKGROUND] = 0
	sprites[spriteid][SPRITE_DISPLAYPOS] = 0
    else
	sprites[spriteid][SPRITE_DISPLAYPOS] = s[1..2]
	if compare(GetBitmapSize(sprites[spriteid][SPRITE_BACKGROUND]),GetBitmapSize(s[3])) or not sprites[spriteid][SPRITE_BACKGROUND] then
	    if sprites[spriteid][SPRITE_BACKGROUND] then
		free(sprites[spriteid][SPRITE_BACKGROUND])
	    end if
	    t = GetBitmapSize(s[3])
	    sprites[spriteid][SPRITE_BACKGROUND] = AllocateScreen(t[1],t[2])
	end if
	BlitSection(buffer,sprites[spriteid][SPRITE_BACKGROUND],s[1],s[2])
	TransBlit(s[3],buffer,s[1],s[2],sprites[spriteid][SPRITE_TRANSPARENT])
	CollisionDetect(s[4],s[1],s[2])
	free(s[3])
	free(s[4])
    end if
end procedure
global function AllocateSprite(object sprite, integer transparent, integer collisionid)
    integer i, width, height
    atom a
    collisionid = GetCollisionId(collisionid)
    i = find(-1,sprites)
    if sequence(sprite) then
	width = length(sprite[1])
	a = AllocateScreen(length(sprite[1]),length(sprite))
	SequenceBlit(sprite,a)
    else
	a = sprite
	sprite = GetBitmapSize(a)
	width = sprite[1]
	height = sprite[2]
    end if
    if i then
	sprites[i] = {a,a,0,0,0,0,0,0,CreateMask(a,transparent,collisionid),transparent,collisionid,0}
    else
	sprites = append(sprites,{a,a,0,0,0,0,0,0,CreateMask(a,transparent,collisionid),transparent,collisionid,0})
	i = length(sprites)
    end if
    UpdateSize(i)
    UpdateCenter(i)
    return i
end function
global procedure DeallocateSprite(integer sprite)
    if sprite > 0 and sprite <= length(sprites) then
	if sequence(sprites[sprite]) then
	    if sprites[sprite][1] then
		free(sprites[sprite][1])
	    end if
	    if sprites[sprite][2] then
		free(sprites[sprite][2])
	    end if
	    if sprites[sprite][3] then
		free(sprites[sprite][3])
	    end if
	    sprites[sprite] = -1
	end if
    end if
end procedure
global procedure DeallocateSpriteEx(integer sprite)
    if sprite > 0 and sprite <= length(sprites) then
	if sequence(sprites[sprite]) then
	    if sprites[sprite][2] then
		free(sprites[sprite][2])
	    end if
	    if sprites[sprite][3] then
		free(sprites[sprite][3])
	    end if
	    sprites[sprite] = -1
	end if
    end if
end procedure
global procedure FreeSprites()
    free(MakeMask)
    free(collide)
    free(CollisionInfo)
    FreeSpriteBuffers()
end procedure
global procedure DisplaySprites()
    object t
    sequence s
    mem_set(maskbuffer+8,0,64000)
    s = {}
    for spriteid = 1 to length(sprites) do
	if sequence(sprites[spriteid]) then
	    if sequence(sprites[spriteid][SPRITE_DISPLAYPOS]) then
		if sprites[spriteid][SPRITE_BACKGROUND] then
		    Blit(sprites[spriteid][SPRITE_BACKGROUND],buffer,sprites[spriteid][SPRITE_DISPLAYPOS][1],sprites[spriteid][SPRITE_DISPLAYPOS][2])
		end if
	    end if
	    s = append(s,ClipSprite(spriteid))
	else
	    s &= 0
	end if
    end for
    for spriteid = 1 to length(sprites) do
	if sequence(sprites[spriteid]) then
	    if integer(s[spriteid]) then
		if sprites[spriteid][SPRITE_BACKGROUND] then
		    free(sprites[spriteid][SPRITE_BACKGROUND])
		end if
		sprites[spriteid][SPRITE_BACKGROUND] = 0
		sprites[spriteid][SPRITE_DISPLAYPOS] = 0
	    else
		sprites[spriteid][SPRITE_DISPLAYPOS] = s[spriteid][1..2]
		if compare(GetBitmapSize(sprites[spriteid][SPRITE_BACKGROUND]),GetBitmapSize(s[spriteid][3])) or not sprites[spriteid][SPRITE_BACKGROUND] then
		    if sprites[spriteid][SPRITE_BACKGROUND] then
			free(sprites[spriteid][SPRITE_BACKGROUND])
		    end if
		    t = GetBitmapSize(s[spriteid][3])
		    sprites[spriteid][SPRITE_BACKGROUND] = AllocateScreen(t[1],t[2])
		end if
		BlitSection(buffer,sprites[spriteid][SPRITE_BACKGROUND],s[spriteid][1],s[spriteid][2])
	    end if
	end if
    end for
    for spriteid = 1 to length(sprites) do
	if sequence(sprites[spriteid]) then
	    if sequence(sprites[spriteid][SPRITE_DISPLAYPOS]) then
		if sequence(s[spriteid]) then
		    TransBlit(s[spriteid][3],buffer,s[spriteid][1],s[spriteid][2],sprites[spriteid][SPRITE_TRANSPARENT])
		    CollisionDetect(s[spriteid][4],s[spriteid][1],s[spriteid][2])
		    free(s[spriteid][3])
		    free(s[spriteid][4])
		end if
	    end if
	end if
    end for
end procedure
collisionEvents = repeat(-1,255)
buffer = AllocateScreen(320,200)
maskbuffer = AllocateScreen(320,200)
sprites = {}
mem_set(buffer+8,0,64000)
mem_set(maskbuffer+8,0,64000)
CollisionInfo = allocate(2)
