-- GFX for Gamelib by Jeffrey Fielding (JJProg@cyberbury.net)
-- version 1.4
-- Sorry, nothing is coded in assembly for speed, but I'll add it soon.
-- New in 1.1:
-- * Speed improvements - poke(a,peek()) replaced with mem_copy
-- New in 1.2:
-- * BlitArea added
-- New in 1.3:
-- * Some routines converted to Assembly
-- New in 1.4:
-- * More assembly routines - TransBlit 10 times faster
-- * RotateBitmap optomized - more than twice as fast
include graphics.e
include machine.e
include misc.e
constant ERROR = allocate(1)
poke(ERROR,0)
constant cpyblit = allocate(136)
poke(cpyblit, {
    #60,                    --    0: pushad
    #BE,#00,#00,#00,#00,    --    1: mov esi, 0 ; Source
    #83,#FE,#00,            --    6: cmp esi, 0
    #75,#16,                --    9: jne copyblit1
    #BE,#00,#00,#0A,#00,    --    B: mov esi, #A0000
    #B8,#00,#FA,#00,#00,    --   10: mov eax, 64000
    #BB,#40,#01,#00,#00,    --   15: mov ebx, 320
    #B9,#C8,#00,#00,#00,    --   1A: mov ecx, 200
    #EB,#0E,                --   1F: jmp copyblit2
			    --   21: copyblit1:
    #8B,#1E,                --   21: mov ebx, DWORD PTR [esi]
    #83,#C6,#04,            --   23: add esi, 4
    #8B,#0E,                --   26: mov ecx, DWORD PTR [esi]
    #83,#C6,#04,            --   28: add esi, 4
    #89,#D8,                --   2B: mov eax, ebx
    #F7,#E1,                --   2D: mul ecx
			    --   2F: copyblit2:
    #BF,#00,#00,#00,#00,    --   2F: mov edi, 0 ; Dest
    #83,#FF,#00,            --   34: cmp edi, 0
    #75,#17,                --   37: jne copyblit3
    #BF,#00,#00,#0A,#00,    --   39: mov edi, #A0000
    #81,#FB,#40,#01,#00,#00,--   3E: cmp ebx, 320
    #75,#38,                --   44: jne copybliterror
    #81,#F9,#C8,#00,#00,#00,--   46: cmp ecx, 200
    #75,#30,                --   4C: jne copybliterror
    #EB,#12,                --   4E: jmp copyblit4
			    --   50: copyblit3:
    #8B,#17,                --   50: mov edx, DWORD PTR [edi]
    #39,#D3,                --   52: cmp ebx, edx
    #75,#28,                --   54: jne copybliterror
    #83,#C7,#04,            --   56: add edi, 4
    #8B,#17,                --   59: mov edx, DWORD PTR [edi]
    #39,#D1,                --   5B: cmp ecx, edx
    #75,#1F,                --   5D: jne copybliterror
    #83,#C7,#04,            --   5F: add edi, 4
			    --   62: copyblit4:
    #8D,#0C,#7F,            --   62: lea ecx, [edi+edi*2]
    #83,#E1,#03,            --   65: and ecx, 3
    #29,#C8,                --   68: sub eax, ecx
    #7E,#0C,                --   6A: jle LEndBytes
    #F3,#A4,                --   6C: rep movsb
    #89,#C1,                --   6E: mov ecx, eax
    #83,#E0,#03,            --   70: and eax, 3
    #C1,#E9,#02,            --   73: shr ecx, 2
    #F3,#A5,                --   76: rep movsd
			    --   78: LEndBytes:
    #01,#C1,                --   78: add ecx, eax
    #F3,#A4,                --   7A: rep movsb
    #61,                    --   7C: popad
    #C3,                    --   7D: ret
			    --   7E: copybliterror:
    #B8,#00,#00,#00,#00,    --   7E: mov eax, 0 ; Error ptr
    #C6,#00,#01,            --   83: mov BYTE PTR [eax], 1
    #61,                    --   86: popad
    #C3})                   --   87: ret
constant CPYBLIT_SOURCE = cpyblit+#2
constant CPYBLIT_DEST = cpyblit+#30
constant CPYBLIT_ERROR = cpyblit+#7F
poke4(CPYBLIT_ERROR,ERROR)
constant tblit = allocate(55)
poke(tblit, {
    #60,                    --    0: pushad
    #BE,#00,#00,#00,#00,    --    1: mov esi, 0 ; Source start
    #BF,#00,#00,#00,#00,    --    6: mov edi, 0 ; Dest start
    #B8,#00,#00,#00,#00,    --    B: mov eax, 0 ; Width
    #BB,#00,#00,#00,#00,    --   10: mov ebx, 0 ; Height
    #B9,#00,#00,#00,#00,    --   15: mov ecx, 0 ; Dest inc
			    --   1A: tblit1:
    #50,                    --   1A: push eax
			    --   1B: tblit2:
    #8A,#16,                --   1B: mov dl, byte ptr [esi]
    #80,#FA,#00,            --   1D: cmp dl, 0  ; Trans color
    #74,#02,                --   20: je skip
    #88,#17,                --   22: mov byte ptr [edi], dl
			    --   24: skip:
    #46,                    --   24: inc esi
    #47,                    --   25: inc edi
    #48,                    --   26: dec eax
    #83,#F8,#00,            --   27: cmp eax, 0
    #75,#EF,                --   2A: jne tblit2
    #01,#CF,                --   2C: add edi, ecx
    #58,                    --   2E: pop eax
    #4B,                    --   2F: dec ebx
    #83,#FB,#00,            --   30: cmp ebx, 0
    #75,#E5,                --   33: jne tblit1
    #61,                    --   35: popad
    #C3})                   --   36: ret
constant tblit_source = tblit+#2
constant tblit_dest = tblit+#7
constant tblit_width = tblit+#C
constant tblit_height = tblit+#11
constant tblit_destinc = tblit+#16
constant tblit_tcolor = tblit+#1F
constant wtrace = allocate(17)
poke(wtrace, {
    #60,                    --    0: pushad
    #66,#BA,#DA,#03,        --    1: mov dx, #3DA
			    --    5: NoRetrace:
    #EC,                    --    5: in al, dx
    #24,#08,                --    6: and al, 8
    #74,#FB,                --    8: jz NoRetrace
			    --    A: Retrace:
    #EC,                    --    A: in al, dx
    #24,#08,                --    B: and al, 8
    #75,#FB,                --    D: jnz Retrace
    #61,                    --    F: popad
    #C3})                   --   10: ret
global constant SCREEN = 0
global function AllocateScreen(integer width, integer height)
    atom r
    r = allocate((width*height)+8)
    if r = 0 then
	return 0
    end if
    poke4(r,{width,height})
    return r
end function
global procedure LoadGfx()
    if graphics_mode(19) then
    end if
end procedure
global procedure UnloadGfx()
    if graphics_mode(-1) then
    end if
    free(ERROR)
    free(cpyblit)
    free(tblit)
    free(wtrace)
end procedure
global procedure wait_retrace()
    call(wtrace)
end procedure
global procedure CopyBlit(atom source, atom dest)
    poke4(CPYBLIT_SOURCE,source)
    poke4(CPYBLIT_DEST,dest)
    call(cpyblit)
    if peek(ERROR) = 1 then
	UnloadGfx()
	puts(1,"Copy blit: Bitmap sizes not the same.\n")
	abort(1)
    end if
end procedure
global procedure Blit(atom source, atom dest, integer x, integer y)
    integer sourceWidth, sourceHeight, destWidth, destHeight
    if source = 0 then
	sourceWidth = 320
	sourceHeight = 200
	source = #A0000
    else
	sourceWidth = peek4u(source)
	sourceHeight = peek4u(source+4)
	source += 8
    end if
    if dest = 0 then
	destWidth = 320
	destHeight = 200
	dest = #A0000
    else
	destWidth = peek4u(dest)
	destHeight = peek4u(dest+4)
	dest += 8
    end if
    if x+sourceWidth > destWidth or y+sourceHeight > destHeight then
	UnloadGfx()
	puts(1,"Blit: blit would have gone off screen.\n")
	abort(1)
    end if
    dest += (destWidth*y)+x
    for i = 1 to sourceHeight do
	mem_copy(dest,source,sourceWidth)
	dest += destWidth
	source += sourceWidth
    end for
end procedure
global procedure TransBlit(atom source, atom dest, integer x, integer y, integer c)
    integer sourceWidth, sourceHeight, destWidth, destHeight, diff, b
    if source = 0 then
	sourceWidth = 320
	sourceHeight = 200
	source = #A0000
    else
	sourceWidth = peek4u(source)
	sourceHeight = peek4u(source+4)
	source += 8
    end if
    if dest = 0 then
	destWidth = 320
	destHeight = 200
	dest = #A0000
    else
	destWidth = peek4u(dest)
	destHeight = peek4u(dest+4)
	dest += 8
    end if
    if x+sourceWidth > destWidth or y+sourceHeight > destHeight then
	UnloadGfx()
	puts(1,"TransBlit: blit would have gone off screen.\n")
	abort(1)
    end if
    dest += (destWidth*y)+x
    diff = destWidth-sourceWidth
    poke4(tblit_source,source)
    poke4(tblit_dest,dest)
    poke4(tblit_width,sourceWidth)
    poke4(tblit_height,sourceHeight)
    poke4(tblit_destinc,diff)
    poke(tblit_tcolor,c)
    call(tblit)
end procedure
global function BlitToSequence(atom source)
    integer sourceWidth, sourceHeight
    sequence dest
    if source = 0 then
	sourceWidth = 320
	sourceHeight = 200
	source = #A0000
    else
	sourceWidth = peek4u(source)
	sourceHeight = peek4u(source+4)
	source += 8
    end if
    dest = repeat(repeat(0,sourceWidth),sourceHeight)
    for i = 1 to sourceHeight do
	dest[i] = peek({source,sourceWidth})
	source += sourceWidth
    end for
    return dest
end function
global procedure SequenceBlit(sequence source, atom dest)
    integer sourceWidth, sourceHeight, destWidth, destHeight
    if dest = 0 then
	dest = #A0000
	destWidth = 320
	destHeight = 200
    else
	destWidth = peek4u(dest)
	destHeight = peek4u(dest+4)
	dest += 8
    end if
    sourceHeight = length(source)
    sourceWidth = length(source[1])
    if destWidth != sourceWidth or destHeight != sourceHeight then
	UnloadGfx()
	puts(1,"SequenceBlit: Bitmap sizes not the same.\n")
	abort(1)
    end if
    for i = 1 to sourceHeight do
	poke(dest,source[i])
	dest += sourceWidth
    end for
end procedure
global procedure BlitSection(atom source, atom dest, integer x, integer y)
    integer sourceWidth, sourceHeight, destWidth, destHeight
    if source = 0 then
	sourceWidth = 320
	sourceHeight = 200
	source = #A0000
    else
	sourceWidth = peek4u(source)
	sourceHeight = peek4u(source+4)
	source += 8
    end if
    if dest = 0 then
	destWidth = 320
	destHeight = 200
	dest = #A0000
    else
	destWidth = peek4u(dest)
	destHeight = peek4u(dest+4)
	dest += 8
    end if
    if x+destWidth > sourceWidth or y+destHeight > sourceHeight then
	UnloadGfx()
	puts(1,"BlitSection: blit would have gone off screen.\n")
	abort(1)
    end if
    source += (sourceWidth*y)+x
    for i = 1 to destHeight do
	mem_copy(dest,source,destWidth)
	dest += destWidth
	source += sourceWidth
    end for
end procedure
global procedure BlitArea(atom source, atom dest, integer destx, integer desty, integer sourcex, integer sourcey, integer sourcewidth, integer sourceheight)
    atom temp
    temp = AllocateScreen(sourcewidth,sourceheight)
    BlitSection(source,temp,sourcex,sourcey)
    Blit(temp,dest,destx,desty)
    free(temp)
end procedure
global function GetBitmapSize(atom bitmap)
    if bitmap = #A0000 then
	return {320,200}
    else
	return peek4u({bitmap,2})
    end if
end function
constant CONVERSION = PI/180
global function RotateBitmap(atom source, atom rotation, integer transparent)
    atom minx, miny, maxx, maxy, r, xaxisx, xaxisy, yaxisx, yaxisy
    atom centerx, centery
    integer x, y, n, c, sizex, sizey, px, py, newsizex, newsizey
    sequence points, dest
    rotation *= CONVERSION
    xaxisx = cos(rotation)
    xaxisy = sin(rotation)
    yaxisx = -xaxisy
    yaxisy = -xaxisx
    if source != 0 then
	sizex = peek4u(source)
	sizey = peek4u(source+4)
	source += 8
    else
	sizex = 320
	sizey = 200
	source = #A0000
    end if
    minx = 0
    maxx = 0
    miny = 0
    maxy = 0
    px = floor(xaxisx*(sizex-1)+yaxisx*(sizey-1))
    py = floor(xaxisy*(sizex-1)-yaxisy*(sizey-1))
    if px < minx then
	minx = px
    elsif px > maxx then
	maxx = px
    end if
    if py < miny then
	miny = py
    elsif py > maxy then
	maxy = py
    end if
    px = floor(xaxisx*(0)+yaxisx*(sizey-1))
    py = floor(xaxisy*(0)-yaxisy*(sizey-1))
    if px < minx then
	minx = px
    elsif px > maxx then
	maxx = px
    end if
    if py < miny then
	miny = py
    elsif py > maxy then
	maxy = py
    end if
    px = floor(xaxisx*(sizex-1)+yaxisx*(0))
    py = floor(xaxisy*(sizex-1)-yaxisy*(0))
    if px < minx then
	minx = px
    elsif px > maxx then
	maxx = px
    end if
    if py < miny then
	miny = py
    elsif py > maxy then
	maxy = py
    end if
    centerx = -minx
    centery = maxy
    newsizex = 1-floor(minx)+floor(maxx)
    newsizey = 1+floor(maxy)-floor(miny)
    dest = repeat(repeat(-1,newsizex),newsizey)
    for i = 0 to sizey-1 do
	for j = 0 to sizex-1 do
	    px = floor(xaxisx*j+yaxisx*i)
	    py = floor(xaxisy*j-yaxisy*i)
	    dest[centery-py+1][centerx+px+1] = peek(source)
	    source += 1
	end for
    end for
    for i = 1 to newsizey do
	for j = 1 to newsizex do
	    if dest[i][j] = -1 then
		n = 0
		for k = -1 to 1 do
		    y = k+i
		    if y > 0 and y <= newsizey then
			for l = -1 to 1 do
			    x = l+j
			    if x > 0 and x <= newsizex then
				if dest[y][x] != -1 then
				    n += 1
				    c = dest[y][x]
				end if
			    end if
			end for
		    end if
		end for
		if n >= 5 then
		    dest[i][j] = c
		else
		    dest[i][j] = transparent
		end if
	    end if
	end for
    end for
    r = AllocateScreen(newsizex,newsizey)
    SequenceBlit(dest,r)
    return r
end function

